﻿using SqlSugar;
using System;

namespace Falcon.SugarApi.DatabaseDefinitions.EntityServices
{
    /// <summary>
    /// 设置禁止升级表架构服务
    /// </summary>
    public class DisableUpdateAllService:IEntityTableServices
    {
        /// <inheritdoc/>
        public void SetupTable(Type t,EntityInfo e) {
            if(t.TryGetAttribute<DisableUpdateAttribute>(out var _)) {
                e.IsDisabledUpdateAll = true;
            }
        }
    }
}
